## tightgatevnc-clientonly 4.4.2~aatgv2

=== CMakeLists.txt ===
#
# Setup
#

cmake_minimum_required(VERSION 2.8.11)
if(POLICY CMP0022)
  cmake_policy(SET CMP0022 OLD)
endif()
if(${CMAKE_VERSION} VERSION_LESS "3.4.0")
  message(WARNING "CMake 3.4.0 or newer is required to get correct default installation paths")
endif()

# Internal cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckTypeSize)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(CheckCSourceRuns)

include(CMakeMacroLibtoolFile)

project(tigervnc)
set(VERSION 4.4.2)

# The RC version must always be four comma-separated numbers
set(RCVERSION 4,4,2)

# Installation paths
include(GNUInstallDirs)
set(CMAKE_INSTALL_UNITDIR "lib/systemd/system" CACHE PATH "systemd unit files (lib/systemd/system)")
if(IS_ABSOLUTE "${CMAKE_INSTALL_UNITDIR}")
  set(CMAKE_INSTALL_FULL_UNITDIR "${CMAKE_INSTALL_UNITDIR}")
else()
  set(CMAKE_INSTALL_FULL_UNITDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_UNITDIR}")
endif()

option(INSTALL_SYSTEMD_UNITS "Install TigerVNC systemd units" ON)

if(MSVC)
  message(FATAL_ERROR "TigerVNC cannot be built with Visual Studio.  Please use MinGW")
endif()

if(NOT BUILD_TIMESTAMP)
  STRING(TIMESTAMP BUILD_TIMESTAMP "%Y-%m-%d %H:%M" UTC)
endif()

# Default to optimised builds instead of debug ones. Our code has no bugs ;)
# (CMake makes it fairly easy to toggle this back to Debug if needed)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")

message(STATUS "VERSION = ${VERSION}")
message(STATUS "BUILD_TIMESTAMP = ${BUILD_TIMESTAMP}")
add_definitions(-DBUILD_TIMESTAMP="${BUILD_TIMESTAMP}")

# We want to keep our asserts even in release builds so remove NDEBUG
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -UNDEBUG")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -UNDEBUG")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -UNDEBUG")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -UNDEBUG")
set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -UNDEBUG")
set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} -UNDEBUG")

# Make sure we get a sane C version
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")

# Tell the compiler to be stringent
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wformat=2")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wformat=2")
# Make sure we catch these issues whilst developing
IF(CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Werror=vla")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Werror=vla")
ENDIF()

option(ENABLE_ASAN "Enable address sanitizer support" OFF)
if(ENABLE_ASAN AND NOT WIN32 AND NOT APPLE)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
endif()

option(ENABLE_TSAN "Enable thread sanitizer support" OFF)
if(ENABLE_TSAN AND NOT WIN32 AND NOT APPLE AND CMAKE_SIZEOF_VOID_P MATCHES 8)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread")
endif()

#if(NOT DEFINED BUILD_WINVNC)
#  set(BUILD_WINVNC 1)
#endif()

# Minimum version is Windows 7
if(WIN32)
  add_definitions(-D_WIN32_WINNT=0x0601)
endif()

# Legacy macros (macOS 10.12 and older) conflict with our code
if(APPLE)
  add_definitions(-D__ASSERT_MACROS_DEFINE_VERSIONS_WITHOUT_UNDERSCORES=0)
endif()

if(CMAKE_SIZEOF_VOID_P MATCHES 8)
  message(STATUS "64-bit build")
else()
  message(STATUS "32-bit build")
endif()

# Versions of CMake before 2.8.7 do not properly support resource compilation
# with MinGW.  Boo!
if(MINGW AND "${CMAKE_VERSION}" VERSION_LESS "2.8.7")
  if(NOT DEFINED RC)
    set(CMAKE_RC_COMPILER_INIT windres)
  else()
    set(CMAKE_RC_COMPILER_INIT ${RC})
  endif()
  enable_language(RC)
  message(STATUS "Resource compiler: ${CMAKE_RC_COMPILER}")
  set(CMAKE_RC_COMPILE_OBJECT
    "<CMAKE_RC_COMPILER> <FLAGS> <DEFINES> -o <OBJECT> --output-format=coff <SOURCE>")
endif()

# MinGW64 has header support but no library support for IActiveDesktop, so we
# need to check for both the header and library and use our own implementation
# in common/os if either doesn't exist.
if(WIN32)
  check_c_source_compiles("#include <windows.h>\n#include <wininet.h>\n#include <shlobj.h>\nint main(int c, char** v) {IActiveDesktop iad; (void)iad; return 0;}" HAVE_ACTIVE_DESKTOP_H)
  check_c_source_compiles("#include <windows.h>\n#include <wininet.h>\n#include <shlobj.h>\nint main(int c, char** v) {GUID i = CLSID_ActiveDesktop; (void)i; return 0;}" HAVE_ACTIVE_DESKTOP_L)
endif()

# X11 stuff. It's in a if() so that we can say REQUIRED
if(UNIX AND NOT APPLE)
  find_package(X11 REQUIRED)
endif()

# Check for zlib
find_package(ZLIB REQUIRED)

# Check for pixman
find_package(Pixman REQUIRED)

# Check for gettext
option(ENABLE_NLS "Enable translation of program messages" ON)
if(ENABLE_NLS)
  # Tools
  find_package(Gettext)

  # Gettext needs iconv
  find_package(Iconv)

  if(ICONV_FOUND)
    # Headers and libraries (copied from licq)
    set(GETTEXT_FOUND FALSE)

    find_path(GETTEXT_INCLUDE_DIR libintl.h)
    if(GETTEXT_INCLUDE_DIR)
      set(CMAKE_REQUIRED_LIBRARIES ${ICONV_LIBRARIES})
      set(CMAKE_REQUIRED_FLAGS -fno-builtin-dgettext)
      check_function_exists(dgettext LIBC_HAS_DGETTEXT)
      if(LIBC_HAS_DGETTEXT)
        set(GETTEXT_FOUND TRUE)
      else()
        find_library(LIBINTL_LIBRARY NAMES intl libintl)
        if(LIBINTL_LIBRARY)
          check_library_exists(${LIBINTL_LIBRARY} "dgettext" "" LIBINTL_HAS_DGETTEXT)
          if(LIBINTL_HAS_DGETTEXT)
            set(GETTEXT_LIBRARIES ${LIBINTL_LIBRARY} ${ICONV_LIBRARIES})
            set(GETTEXT_FOUND TRUE)
          endif()
        endif()
      endif()
      set(CMAKE_REQUIRED_LIBRARIES)
      set(CMAKE_REQUIRED_FLAGS)
    endif()
  endif()

  if(NOT GETTEXT_FOUND OR NOT ICONV_FOUND)
    message(WARNING "Gettext NOT found.  Native Language Support disabled.")
    set(ENABLE_NLS 0)
  endif()
endif()

# Check for libjpeg
find_package(JPEG REQUIRED)

# Warn if it doesn't seem to be the accelerated libjpeg that's found
set(CMAKE_REQUIRED_LIBRARIES ${JPEG_LIBRARIES})
set(CMAKE_REQUIRED_FLAGS -I${JPEG_INCLUDE_DIR})
if (NOT APPLE)
  set(CMAKE_REQUIRED_FLAGS -I/usr/include/glib-2.0 -I/usr/lib/x86_64-linux-gnu/glib-2.0/include)
endif()

set(JPEG_TEST_SOURCE "\n
  #include <stdio.h>\n
  #include <jpeglib.h>\n
  int main(void) {\n
    struct jpeg_compress_struct cinfo;\n
    struct jpeg_error_mgr jerr;\n
    cinfo.err=jpeg_std_error(&jerr);\n
    jpeg_create_compress(&cinfo);\n
    cinfo.input_components = 3;\n
    jpeg_set_defaults(&cinfo);\n
    cinfo.in_color_space = JCS_EXT_RGB;\n
    jpeg_default_colorspace(&cinfo);\n
    return 0;\n
  }")

if(CMAKE_CROSSCOMPILING)
  check_c_source_compiles("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
else()
  check_c_source_runs("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
endif()

set(CMAKE_REQUIRED_LIBRARIES)
set(CMAKE_REQUIRED_FLAGS)
set(CMAKE_REQUIRED_DEFINITIONS)

if(NOT FOUND_LIBJPEG_TURBO)
  message(STATUS "WARNING: You are not using libjpeg-turbo. Performance will suffer.")
endif()

if (NOT APPLE)
  include_directories(${JPEG_INCLUDE_DIR} /usr/include/glib-2.0 /usr/lib/x86_64-linux-gnu/glib-2.0/include)
endif()

option(BUILD_JAVA "Build Java version of the TigerVNC Viewer" FALSE)
if(BUILD_JAVA)
  add_subdirectory(java)
endif()

# Check for FLTK
set(FLTK_SKIP_FLUID TRUE)
set(FLTK_SKIP_OPENGL TRUE)
set(FLTK_SKIP_FORMS TRUE)
find_package(FLTK)

if(UNIX AND NOT APPLE)
  # No proper handling for extra X11 libs that FLTK might need...
  if(X11_Xft_FOUND)
    # Xft headers include references to fontconfig, so we need
    # to link to that as well
    find_library(FONTCONFIG_LIB fontconfig)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xft_LIB} ${FONTCONFIG_LIB})
  endif()
  if(X11_Xinerama_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xinerama_LIB})
  endif()
  if(X11_Xfixes_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xfixes_LIB})
  endif()
  if(X11_Xcursor_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xcursor_LIB})
  endif()
  if(X11_Xrender_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xrender_LIB})
  endif()
endif()

# Check for GNUTLS library
option(ENABLE_GNUTLS "Enable protocol encryption and advanced authentication" ON)
if(ENABLE_GNUTLS)
  find_package(GnuTLS)
  if (GNUTLS_FOUND)
    include_directories(${GNUTLS_INCLUDE_DIR})
    add_definitions("-DHAVE_GNUTLS")
    add_definitions(${GNUTLS_DEFINITIONS})
  endif()
endif()

# Check for PAM library
if(UNIX AND NOT APPLE)
  check_include_files(security/pam_appl.h HAVE_PAM_H)
  set(CMAKE_REQUIRED_LIBRARIES -lpam)
  check_function_exists(pam_start HAVE_PAM_START)
  set(CMAKE_REQUIRED_LIBRARIES)
  if(HAVE_PAM_H AND HAVE_PAM_START)
    set(PAM_LIBS pam)
  else()
    message(FATAL_ERROR "Could not find PAM development files")
  endif()
endif()

# Check for socket functions
if(WIN32)
  set(CMAKE_EXTRA_INCLUDE_FILES winsock2.h ws2tcpip.h)
  # check_function_exists() cannot handle stdcall, so just define things
  set(HAVE_INET_ATON 1)
  set(HAVE_GETADDRINFO 1)
else()
  check_function_exists(inet_aton HAVE_INET_ATON)
  check_function_exists(getaddrinfo HAVE_GETADDRINFO)
  set(CMAKE_REQUIRED_LIBRARIES)
  set(CMAKE_EXTRA_INCLUDE_FILES sys/socket.h)
endif()
check_function_exists(inet_aton HAVE_INET_ATON)
check_function_exists(getaddrinfo HAVE_GETADDRINFO)
set(CMAKE_EXTRA_INCLUDE_FILES)
set(CMAKE_REQUIRED_LIBRARIES)

check_function_exists(gettid HAVE_GETTID)

# Generate config.h and make sure the source finds it
configure_file(config.h.in config.h)
add_definitions(-DHAVE_CONFIG_H)
include_directories(${CMAKE_BINARY_DIR})

include(cmake/StaticBuild.cmake)

add_subdirectory(common)

if(WIN32)
  add_subdirectory(win)
else()
  # No interest in building x related parts on Apple
  if(NOT APPLE)
    add_subdirectory(unix)
  endif()
endif()

if(ENABLE_NLS)
  add_subdirectory(po)
endif()

option(BUILD_VIEWER "Build TigerVNC viewer" ON)
if(BUILD_VIEWER)
  add_subdirectory(vncviewer)
  add_subdirectory(media)
endif()

add_subdirectory(tests)


add_subdirectory(release)

# uninstall
configure_file("${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "cmake_uninstall.cmake" IMMEDIATE @ONLY)

add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P cmake_uninstall.cmake)

=== media/CMakeLists.txt ===
set(ICON_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_16.png
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_32.png
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_48.png
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_128.png
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_256.png)

find_program(CONVERT_EXECUTABLE convert)

if(CONVERT_EXECUTABLE)
  add_custom_target(icons DEPENDS ${ICON_FILES})

  if(UNIX AND NOT APPLE)
    foreach(SIZE 16 32 48 128 256)
      install(FILES icons/tightgatevnc_${SIZE}.png
        DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${SIZE}x${SIZE}/apps
        RENAME tightgatevnc.png)
    endforeach()
    install(FILES icons/tightgatevnc.svg
      DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/scalable/apps)
  endif()
endif()

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_16.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8 -background transparent
    ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_16.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg
  COMMENT "Generating icons/tightgatevnc_16.png")

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_32.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8
    -scale 32x32 xc:none -gravity center -background transparent
    ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg -composite
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_32.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg
  COMMENT "Generating icons/tightgatevnc_32.png")

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_48.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8
    -scale 48x48 xc:none -gravity center -background transparent
    ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg -composite
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_48.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg
  COMMENT "Generating icons/tightgatevnc_48.png")

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_128.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8
    -scale 128x128 xc:none -gravity center -background transparent
    ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg -composite
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_128.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg
  COMMENT "Generating icons/tightgatevnc_128.png")

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_256.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8
    -scale 256x256 xc:none -gravity center -background transparent
    ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg -composite
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc_256.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tightgatevnc.svg
  COMMENT "Generating icons/tightgatevnc_256.png")

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc.ico
  COMMAND ${CONVERT_EXECUTABLE} -density 72
    -scale 256x256 xc:none -gravity center -background transparent -colors 256
    ${ICON_FILES}
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/tightgatevnc.ico
  DEPENDS ${ICON_FILES}
  COMMENT "Generating icons/tightgatevnc.ico")

=== media/Makefile ===
all: icons/tightgatevnc.ico

.PHONY: clean
clean: clean-icons

ICONS := \
    icons/tightgatevnc_16.png \
    icons/tightgatevnc_22.png \
    icons/tightgatevnc_24.png \
    icons/tightgatevnc_32.png \
    icons/tightgatevnc_48.png \
    icons/tightgatevnc_128.png

.PHONY: icons clean-icons
icons: $(ICONS)

clean-icons:
	rm -f $(ICONS)

icons/tightgatevnc_16.png: tightgatevnc.svg
	convert -scale 16x16 -background transparent "$<" "$@"
icons/tightgatevnc_22.png: tightgatevnc.svg
	convert -scale 22x22 -background transparent "$<" "$@"
icons/tightgatevnc_24.png: tightgatevnc.svg
	convert -scale 24x24 -background transparent "$<" "$@"
icons/tightgatevnc_32.png: tightgatevnc.svg
	convert -scale 32x32 -background transparent "$<" "$@"
icons/tightgatevnc_48.png: tightgatevnc.svg
	convert -scale 48x48 -background transparent "$<" "$@"
icons/tightgatevnc_128.png: tightgatevnc.svg
	convert -scale 128x128 -background transparent "$<" "$@"
icons/tightgatevnc.ico: $(ICONS)
	convert -background transparent $(ICONS) "$@"

=== vncviewer/CMakeLists.txt ===
include_directories(${FLTK_INCLUDE_DIR})
include_directories(${GETTEXT_INCLUDE_DIR})

if(WIN32)
  # These are used for printing pdfs only in Windows
  include_directories(${POPPLER_INCLUDE_DIR})
  include_directories(${GLIB_INCLUDE_DIR_1})
  include_directories(${GLIB_INCLUDE_DIR_2})
  include_directories(${CAIRO_INCLUDE_DIR})
endif()

include_directories(${CMAKE_SOURCE_DIR}/common)
set(VNCVIEWER_SOURCES
  tgpro_helpers.cxx
  sound_handler.cxx
  ConnectingMessage.cxx
  PrintDialog.cxx
  MagicUrlHelper.cxx
  UrlWhitelistHandler.cxx
  NativeMessagingApp.cxx
  CAutotransferHandler.cxx
  menukey.cxx
  BaseTouchHandler.cxx
  CConn.cxx
  DesktopWindow.cxx
  EmulateMB.cxx
  UserDialog.cxx
  ServerDialog.cxx
  Surface.cxx
  StreamDialog.cxx
  OptionsDialog.cxx
  PlatformPixelBuffer.cxx
  Viewport.cxx
  parameters.cxx
  keysym2ucs.c
  touch.cxx
  vncviewer.cxx)

if(WIN32)
  # Since vncviewer.rc is generated, local includes will be looking
  # in the wrong directory. We need to help it out.
  include_directories(${CMAKE_CURRENT_SOURCE_DIR})
  configure_file(vncviewer.rc.in vncviewer.rc)
  set(VNCVIEWER_SOURCES
    ${VNCVIEWER_SOURCES}
    ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.rc)
endif()

if(WIN32)
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} Win32TouchHandler.cxx win32.c pdfprinter.cxx printing.cxx MagicUrlHelper.cxx)
elseif(APPLE)
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} cocoa.mm printing.cxx osx_to_qnum.c)
else()
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} GestureHandler.cxx XInputTouchHandler.cxx printing.cxx xkb_to_qnum.c)
endif()

if(WIN32)
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} Surface_Win32.cxx)
elseif(APPLE)
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} Surface_OSX.cxx)
else()
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} Surface_X11.cxx)
endif()

if(WIN32 AND NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_executable(vncviewer WIN32 ${VNCVIEWER_SOURCES})
else()
  add_executable(vncviewer ${VNCVIEWER_SOURCES})
endif()

find_library(MPRIVACY_LIBRARY
  NAMES mprivacy libmprivacy
  HINTS "/usr/x86_64-apple-darwin19/lib/")

target_link_libraries(vncviewer rfb ${MPRIVACY_LIBRARY} network rdr os ${FLTK_LIBRARIES} ${GETTEXT_LIBRARIES})

# libmprivacy needs psapi on woe32.
if(WIN32)
  target_link_libraries(vncviewer msimg32 psapi wtsapi32 dbghelp)
elseif(APPLE)
  target_link_libraries(vncviewer "-framework Cocoa")
  target_link_libraries(vncviewer "-framework Carbon")
  target_link_libraries(vncviewer "-framework IOKit")
  target_link_libraries(vncviewer "-lfltk")
else()
  target_link_libraries(vncviewer ${X11_Xi_LIB})
endif()

if(UNIX)
#  target_link_libraries(vncviewer "-Wl,-Bstatic -lkrb5 -lkrb5support -lgssapi_krb5 -lk5crypto -Wl,-Bdynamic")
  target_link_libraries(vncviewer "-lkrb5 -lzstd")
endif()

install(TARGETS vncviewer DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
if(UNIX)
  install(FILES vncviewer.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1 RENAME vncviewer.1)

  configure_file(vncviewer.desktop.in.in vncviewer.desktop.in)
  find_program(INTLTOOL_MERGE_EXECUTABLE intltool-merge)
  if("${GETTEXT_VERSION_STRING}" VERSION_GREATER 0.18.99)
    add_custom_command(OUTPUT vncviewer.desktop
      COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
                --desktop --template vncviewer.desktop.in
                -d ${CMAKE_SOURCE_DIR}/po -o vncviewer.desktop
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop.in
    )
  elseif(INTLTOOL_MERGE_EXECUTABLE)
    add_custom_command(OUTPUT vncviewer.desktop
      COMMAND sed -e 's/^Name/_Name/'
                -e 's/^GenericName/_GenericName/'
                -e 's/^Comment/_Comment/'
                vncviewer.desktop.in > vncviewer.desktop.intl
      COMMAND ${INTLTOOL_MERGE_EXECUTABLE}
                -d ${CMAKE_SOURCE_DIR}/po
                vncviewer.desktop.intl vncviewer.desktop
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop.in
    )
  else()
    add_custom_command(OUTPUT vncviewer.desktop
      COMMAND cp vncviewer.desktop.in vncviewer.desktop
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop.in
    )
  endif()
  add_custom_target(desktop ALL DEPENDS vncviewer.desktop)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications)

  foreach(res 16 22 24 32 48)
    install(FILES ../media/icons/tightgatevnc_${res}.png DESTINATION ${DATA_DIR}/icons/hicolor/${res}x${res}/apps RENAME tightgatevnc.png)
  endforeach()
  install(FILES ../media/icons/tightgatevnc.svg DESTINATION ${DATA_DIR}/icons/hicolor/scalable/apps)
endif()

=== common/rfb/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common ${JPEG_INCLUDE_DIR} ${PIXMAN_INCLUDE_DIR})

set(RFB_SOURCES
  Blacklist.cxx
  Congestion.cxx
  CConnection.cxx
  CMsgHandler.cxx
  CMsgReader.cxx
  CMsgWriter.cxx
  CSecurityPlain.cxx
  CSecurityStack.cxx
  CSecurityKrb.cxx
  CSecurityMulti.cxx
  ../../vncviewer/MagicUrlHelper.cxx
  ../../vncviewer/CAutotransferHandler.cxx
  ../../vncviewer/PrintDialog.cxx
  CSecurityVeNCrypt.cxx
  CSecurityVncAuth.cxx
  CWebcamHandler.cxx
  ClientParams.cxx
  ComparingUpdateTracker.cxx
  Configuration.cxx
  CopyRectDecoder.cxx
  Cursor.cxx
  DecodeManager.cxx
  Decoder.cxx
  d3des.c
  EncodeManager.cxx
  Encoder.cxx
  HextileDecoder.cxx
  HextileEncoder.cxx
  JpegCompressor.cxx
  JpegDecompressor.cxx
  MPCompressor.cxx
  MPDecompressor.cxx
  KeyRemapper.cxx
  LogWriter.cxx
  Logger.cxx
  Logger_file.cxx
  Logger_stdio.cxx
  Password.cxx
  PixelBuffer.cxx
  PixelFormat.cxx
  RREEncoder.cxx
  RREDecoder.cxx
  RawDecoder.cxx
  RawEncoder.cxx
  Region.cxx
  SConnection.cxx
  SMsgHandler.cxx
  SMsgReader.cxx
  SMsgWriter.cxx
  ServerCore.cxx
  ServerParams.cxx
  Security.cxx
  SecurityServer.cxx
  SecurityClient.cxx
  SSecurityPlain.cxx
  SSecurityCert.cxx
  SSecurityMulti.cxx
  SSecurityStack.cxx
  SSecurityVncAuth.cxx
  SSecurityVeNCrypt.cxx
  ScaleFilters.cxx
  Timer.cxx
  TightDecoder.cxx
  TightEncoder.cxx
  TightJPEGEncoder.cxx
  TightMPEncoder.cxx
  UpdateTracker.cxx
  VNCSConnectionST.cxx
  VNCServerST.cxx
  ZRLEEncoder.cxx
  ZRLEDecoder.cxx
  encodings.cxx
  util.cxx)

if (NOT APPLE)
  if (NOT WIN32)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferDirWatcher.cxx)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferNow.cxx)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferMime.cxx)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferOpswat.cxx)
    set(RFB_SOURCES ${RFB_SOURCES} SAutotransferVaithex.cxx)
  endif()
  set(RFB_SOURCES ${RFB_SOURCES} SWebcamHandler.cxx)
  set(RFB_SOURCES ${RFB_SOURCES} ../../vncviewer/printing.cxx)
  set(RFB_SOURCES ${RFB_SOURCES} SSecurityKrb.cxx)
endif()

if(UNIX)
  set(RFB_SOURCES ${RFB_SOURCES} Logger_syslog.cxx)
endif()

if(WIN32)
  include_directories(${CMAKE_SOURCE_DIR}/win)
  set(RFB_SOURCES ${RFB_SOURCES} WinPasswdValidator.cxx)
endif(WIN32)

if(WIN32)
  set(RFB_LIBRARIES "-Wl,-Bstatic ${JPEG_LIBRARIES} ${PIXMAN_LIBRARY} ${MP_LIBRARIES} -Wl,-Bdynamic" os rdr "-Wl,-Bstatic -lgsasl -lidn -lntlm -lsecur32 -liconv -Wl,-Bdynamic")
else()
  set(RFB_LIBRARIES ${JPEG_LIBRARIES} ${PIXMAN_LIBRARY} ${MP_LIBRARIES} os rdr "-lkrb5 -lk5crypto -lkrb5support -lgssapi_krb5 -lgsasl -lidn -lntlm")
endif()

if(UNIX)
  set(RFB_LIBRARIES ${RFB_LIBRARIES} "-lmprivacy -lmagic -lcurl -lopenh264 -lzstd -larchive")
  if(APPLE)
    set(RFB_LIBRARIES ${RFB_LIBRARIES} "-lgio-2.0 -lgobject-2.0 -lgmodule-2.0 -lglib-2.0 -lpcre -lffi")
  else()
    set(RFB_LIBRARIES ${RFB_LIBRARIES} "-lunistring -lidn2 -lgnutls -lcap -lgio-2.0 -lglib-2.0 -lpcre2-8 -lmount -lffi -lblkid -luuid -lbrotlidec -lbrotlienc -lbrotlicommon -lhwy -llcms2 -ljxl -ljxl_threads")
  endif()
else()
  set(RFB_LIBRARIES ${RFB_LIBRARIES} "-Wl,-Bstatic -lmprivacy -lopenh264 -lzstd -ljxl -lhwy -lbrotlidec -lbrotlicommon -lversion -Wl,-Bdynamic")
endif()

if(UNIX AND NOT APPLE)
  set(RFB_SOURCES ${RFB_SOURCES} UnixPasswordValidator.cxx
    UnixPasswordValidator.h pam.c pam.h)
  set(RFB_LIBRARIES ${RFB_LIBRARIES} ${PAM_LIBS})
endif()

if(GNUTLS_FOUND)
  set(RFB_SOURCES
    ${RFB_SOURCES}
    CSecurityTLS.cxx
    SSecurityTLS.cxx
  )
  set(RFB_LIBRARIES
    ${RFB_LIBRARIES}
    ${GNUTLS_LIBRARIES}
  )
endif()

add_library(rfb STATIC ${RFB_SOURCES})

target_link_libraries(rfb ${RFB_LIBRARIES})

if(UNIX)
  libtool_create_control_file(rfb)
endif()

=== debian/changelog ===
tightgatevnc-clientonly (4.4.2~aatgv2) testing; urgency=low

  * Rebuild with new libs

 -- Amon Ott <ao@m-privacy.de>  Wed, 18 Jun 2025 13:07:00 +0200

tightgatevnc-clientonly (4.4.2~aatgv1) testing; urgency=low

  * Build with new libs
  * git (rebase-20210322-4.4) b39096634b712d3382d9e1ae225e2c2e32b76dd1
    vncviewer.cxx: Add timestamp to log file for Windows.
    (cherry picked from commit 57fa09df71b9be55fa43c955dcfd457cbec09cb8)
  * git (rebase-20210322-4.4) cbcbc8a7d7d15c716df5907db9c1c83481eb9b78
    BUG 0006988: MagicUrl Add-On für Chrome und Edge (Manifest v3)
    vncviewer.cxx: Make the viewer understand the new tightgate://
    Windows URL protocol so that 'TightGate-Extension' can use it
    to open the viewer.
    Just remove the tightgate:// from the beginning of the initialURL
    param.
    (cherry picked from commit a139f7bc83e55c2248bfd92a35e1c37cb7ceebee)
  * git (rebase-20210322-4.4) 6d3f073d798f0c818ceb9c2f28ba1917aa476ed0
    BUG 0006988: MagicUrl Add-On für Chrome und Edge (Manifest v3)
    Add UrlWhitelistHandler and NativeMessagingApp namespaces with code
    from browserchoice.c to be able to communicate through stdin and stdout
    as native messaging host app.
    Add it to CMakeLists for Windows so that it compiles.
    (cherry picked from commit 500845a53a1be855c914dad37108841b21fb4d5c)
  * git (rebase-20210322-4.4) b1101ef0c13518e2a263946e5b580800e7af4bbf
    BUG 0006988: MagicUrl Add-On für Chrome und Edge (Manifest v3)
    vncviewer.cxx: Actually use NativemessagingApp to read from stdin
    if necessary and communicate with the add-on (only v3 implemented
    here).
    (cherry picked from commit 2f37ec6091880ca426eb68449eb3646c04a0ab28)
  * git (rebase-20210322-4.4) 922414e57894b4b5d2edb051121a68b7caa6e98b
    vncviewer: Add AliasParameter url for initialURL (just for
    convenience).
    (cherry picked from commit dd3ac8bdc4388865b5aaebe1b8da7821fd67be74)
  * git (rebase-20210322-4.4) fbc0603eae37a3ce11b46136dbadc6ee5bdbae15
    vnviewer: Move tightgate:// removal to fixInitialUrl() function.
    (cherry picked from commit cc55b6f2da7c28dc862791a68beb4ea16308c6dc)
  * git (rebase-20210322-4.4) b7310103a1638beffd3283cd0e8f979c94bdb71d
    BUG 0006988: MagicUrl Add-On für Chrome und Edge (Manifest v3)
    vncviewer.exe: Newest Chrome seems to remove the : from the protocol
    creating a URL like this: tightgate://https//m-privacy.de.
    Fix URL by adding the missing ':'.
    (cherry picked from commit d6b7b1799eb5889a657a59691a109b22dde2cfc1)
  * git (rebase-20210322-4.4) f52a4c091447847855455d3dd4cc3318bd1191a3
    BUG 0006794: OPSWAT: Fehlermeldung für das Verschwinden von Dateien bei zu langen Dateinamen
    CAutotransferHandler: Do not allow AutotransferDir length > 100.
    Show a log error line and don't accept it.
    CSecurityMulti: Mercilessly truncate file paths to 250 to allow
    some wiggle room for renaming with numbers if necessary.
    Note: Our docs should say that folders with length > 100 and
    filenames with length 150 are not allowed.
    Technically, only the dir is not allowed to be greater
    than 100 chars (which is a lot). Some filenames might not be
    truncated depending on the length of %temp%\tgprotemp or AutotransferDir.
    (cherry picked from commit a02fd3dc2355c9527ee97f5b3897ec531820ee82)
  * git (rebase-20210322-4.4) 889ecaa0bb27cd15ece74cdb8a66a3e4e83db589
    Update xorg to 21.1.14
  * git (rebase-20210322-4.4) eea509fe845855cd5a18fa076ec79d1baa496801
    Version 4.4.2

 -- Amon Ott <ao@m-privacy.de>  Tue, 12 Nov 2024 10:00:00 +0100

tightgatevnc-clientonly (4.4.1~aatgv2) testing; urgency=low

  * Build with new libs
  * git (rebase-20210322-4.4) 2211e060413bab2c1e23309673b4880fcce34540
    BUG 0006900: Viewer: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)
    Just call create_send_to_shortcut directly (#ifdef WIN32) and leave
    the checks to the function itself.
  * git (rebase-20210322-4.4) 9c0f61c09e7e6ad9439524ce62cc2823dd9e1c9f
    pam.c: define mplog_error and mplog_info as syslog logs so that
    we can see those in auth.log. There is not vlog here and it's
    difficult to add. Like this we show important info in auth.log.

 -- Amon Ott <ao@m-privacy.de>  Wed, 25 Sep 2024 10:44:00 +0200

tightgatevnc-clientonly (4.4.1~aatgv1) testing; urgency=low

  * git (rebase-20210322-4.4) fa93cc53312a05a68b3494790afe6a65fbaf4405
    Version 4.4.1

 -- Amon Ott <ao@m-privacy.de>  Tue, 09 Jul 2024 09:31:00 +0200

tightgatevnc-clientonly (4.4.0~aatgv4) testing; urgency=low

  * debian/rules:
    - do not rename files below debian/tmp/usr/share/locale/
  * debian/control:
    - Build-Depend on gettext-base
  * git (rebase-20210322-4.4) 374bb22c9e2bdbd4bce9180f95eed3dc00f52c00
    SAutotransferVaithex: fix mp_move call so that destination is not
    equal to origin.
  * git (rebase-20210322-4.4) f8c25d75d9c44260b480489b00f458b3ad05034f
    SAutotransferVaithex: Files can be scanned without selecting an AV in the config menu.
  * git (rebase-20210322-4.4) 8200d5a3ea2f05288336b5152a232b17e9fa0ac6
    BUG 0006900: Viewer: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)
    Create vncviewer/SendToShortcutHelper that is used to call
    create_send_to_shortcut(configDir, description) from libmprivacy.
    vncviewer: instantiate and use SendToShortcutHelper.
  * git (rebase-20210322-4.4) 1dc912433d934d7ede69d3dbb6461fe4f3f87c1a
    BUG 0006900: Viewer: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)
    Add German and Spanish translation for "Send file to TightGate-Pro".
  * git (rebase-20210322-4.4) 846fcbb26407fad6ed2d24f555834979561e0c5c
    Revert "BUG 0006900: Viewer: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)"
    This reverts commit 8200d5a3ea2f05288336b5152a232b17e9fa0ac6.
    I'm reverting it because it was breaking linux builds and I'm moving
    all the logic to tgpro_environment.


=== debian/control ===
Source: tightgatevnc-clientonly
Section: x11
Priority: optional
Maintainer: m-privacy GmbH (<info@m-privacy.de>)
Build-Depends: debhelper (>= 4.0.0), perl, gcc, g++, sed,
 libgettextpo-dev, cmake, libxft-dev, libcap-dev, libaudit-dev,
 libxinerama-dev, libpng-dev, libfltk1.3-dev,
 libturbojpeg0-dev, libjpeg62-turbo-dev, zlib1g-dev, automake1.9 | automake1.11, autoconf,
 xserver-xorg-dev, xutils, pkg-config, x11proto-bigreqs-dev,
 x11proto-composite-dev, x11proto-core-dev (>= 7.0.26), x11proto-damage-dev,
 x11proto-fixes-dev, x11proto-kb-dev (>= 1.0.1-1), x11proto-xinerama-dev,
 x11proto-randr-dev (>= 1.4.0), x11proto-record-dev, x11proto-render-dev,
 x11proto-resource-dev, x11proto-scrnsaver-dev, x11proto-video-dev,
 x11proto-xcmisc-dev, x11proto-xext-dev (>= 7.2.99.901),
 x11proto-xf86bigfont-dev, x11proto-xf86dga-dev,
 x11proto-xf86vidmode-dev, xtrans-dev (>= 1.3.3), libxau-dev (>= 1:0.1.2-1),
 libxdmcp-dev (>= 1:0.1.3-2), libxfont-dev (>= 2), libfontenc-dev,
 libxkbfile-dev (>= 7.0.0-1), x11proto-xf86dri-dev, libdrm-dev (>> 2.0),
 x11proto-gl-dev (>= 1.4.1-1), libgl1-mesa-dev (>= 7.8.0), libxmuu-dev (>= 1:1.0.2-2),
 libxext-dev (>= 1:1.0.1-2), libx11-dev (>= 1:6.2.1+cvs.20050722-1),
 libxrender-dev (>= 1:0.9.0-1), libxi-dev (>= 1:1.0.1-4), x11proto-dmx-dev,
 dpatch, libdmx-dev, libxpm-dev (>= 1:3.5.3-1), libxaw7-dev (>= 1:1.0.2-4),
 libxt-dev (>> 1:0.99.3+cvs.20051212), libxmu-dev (>= 1:1.0.2-2),
 libxtst-dev (>= 1:1.0.1-5), libxres-dev (>= 1:1.0.2+0.99.1-1),
 libfreetype6-dev, flex, dpatch, gnutls28-nop11-dev | libgnutls28-dev, nasm, libtool,
 x11proto-gl-dev, libpciaccess-dev, libexpat1-dev, cvs,
 libpam0g-dev, autopoint, xutils-dev, x11proto-fonts-dev (>= 2.1.3),
 x11proto-input-dev (>= 2.3), x11proto-dri2-dev, libxxf86vm-dev, libxfixes-dev,
 libsm-dev, libice-dev, libpixman-1-dev, libxdamage-dev, libglu1-mesa-dev,
 libosmesa6-dev, mesa-common-dev, libpthread-stubs0-dev,
 xfonts-utils (>= 7.5), libgcrypt-dev, libgsasl7-dev (>= 1.8.0),
 libgsasl7-dev (<< 1.8.0-3),
 libmprivacy (>= 1.0.55+aatgv1), libtasn1-6-dev, nettle-dev,
 libkrb5support0-static | libkrb5-dev, libkrb5-static-3 | libkrb5-dev, libgssapi-krb5-static-2 | libkrb5-dev,
 libkeyutils-dev, librsvg2-bin, libxcursor-dev, libbz2-dev,
 libc6-dev, libssh-dev, libnacl-dev, libcurl4-gnutls-dev,
 x11proto-present-dev, libb64-dev, fluid, libjemalloc-dev, libmagic-dev, rename,
 libglib2.0-dev, libmount-dev, libunistring-dev, libidn2-dev,
 libopenh264-dev (>= 2.3.1-2), libzstd-dev, libwebp-dev, libbrotli-dev,
 nlohmann-json3-dev, libunwind-dev,
 comerr-dev, libjxl-dev, libmount-dev (<< 2.36.1-8+),
 libarchive-dev, gettext-base
Build-Conflicts: libc6 (>= 2.32)
Standards-Version: 3.6.1

Package: tightgateviewer
Section: net
Architecture: any
Provides: vnc-viewer
Replaces: xvnc4viewer, tigervncviewer
Depends: libc6 (>> 2.31), ${shlibs:Depends}
Conflicts: tightgateviewer-internal
Recommends: gstreamer1.0-tools, daemon, v4l-utils, ffmpeg
Suggests: tightgatevnc-common
Description: TightGate-Pro VNC client
 VNC stands for Virtual Network Computing. It is, in essence, a remote
 display system which allows you to view a computing `desktop' environment
 not only on the machine where it is running, but from anywhere on the
 Internet and from a wide variety of machine architectures.
 .
 It is implemented in a client/server model. This package provides a vncclient
 for X, with this you can connect to a vncserver somewhere in the network
 and display its content in a window. There are vncserver available for X
 and for Win95/NT.

=== contrib/packages/deb/ubuntu-focal/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 by Joey Hess.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CFLAGS   := $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

export CFLAGS CPPFLAGS CXXFLAGS LDFLAGS

NUMJOBS := -j$(shell nproc)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build=$(DEB_HOST_GNU_TYPE)
else
	confflags += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif
SOURCE_NAME    := tigervnc
SOURCE_VERSION := $(shell dpkg-parsechangelog | awk -F': ' '/^Version: / {print $$2}')
BUILDER=For technical support please see http://sourceforge.net/projects/tigervnc/support
libdir = /usr/lib/$(DEB_HOST_MULTIARCH)


ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g -O2 -fPIC
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

export CC = gcc

# use xorg sources as shipped in xorg-server-source package
XORG_SOURCE_ARCHIVE = /usr/src/xorg-server.tar.xz

xorg-source-stamp: $(XORG_SOURCE_ARCHIVE)
	tar -C unix/xserver -axf $(XORG_SOURCE_ARCHIVE) --strip-components=1
	cd unix/xserver && patch -p1 < ../xserver120.patch
	patch -p1 < debian/xorg-source-patches/100_rethrow_signals.patch
	patch -p1 < debian/xorg-source-patches/516_tigervnc-xorg-manpages.patch
	touch xorg-source-stamp

configure: config-stamp
config-stamp: xorg-source-stamp
	dh_testdir
	# Add here commands to configure the package.
	cmake -G"Unix Makefiles" \
		-DBUILD_STATIC=off \
		-DCMAKE_INSTALL_PREFIX:PATH=/usr \
		-DCMAKE_INSTALL_LIBEXECDIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_INSTALL_UNITDIR:PATH=/lib/systemd/system
	(cd unix/xserver; \
	export PIXMANINCDIR=/usr/include/pixman-1; \
	autoreconf -fiv; \
  patch -p1 -i ../../debian/xorg-source-patches/debian_libtool.patch; \
	./configure --prefix=/usr \
		--disable-silent-rules \
		--disable-static \
		--without-dtrace \
		--disable-strict-compilation \
		--disable-debug \
		--disable-unit-tests \
		--with-int10=x86emu \
		--with-extra-module-dir="/usr/lib/${DEB_HOST_MULTIARCH}/xorg/extra-modules,/usr/lib/xorg/extra-modules" \
		--with-os-vendor="$(VENDOR)" \
		--with-builderstring="$(SOURCE_NAME) $(SOURCE_VERSION) ($(BUILDER))" \
		--with-xkb-path=/usr/share/X11/xkb \
		--with-xkb-output=/var/lib/xkb \
		--with-default-xkb-rules=evdev \
		--disable-devel-docs \
		--enable-mitshm \
		--enable-xres \
		--disable-xcsecurity \
		--disable-tslib \
		--enable-dbe \
		--disable-xf86bigfont \
		--disable-dpms \
		--disable-config-hal \
		--disable-config-udev \
		--disable-xorg \
		--disable-xquartz \
		--disable-xwin \
		--disable-xfake \
		--disable-install-setuid \
		--with-default-font-path="/usr/share/fonts/X11/misc,/usr/share/fonts/X11/cyrillic,/usr/share/fonts/X11/100dpi/:unscaled,/usr/share/fonts/X11/75dpi/:unscaled,/usr/share/fonts/X11/Type1,/usr/share/fonts/X11/100dpi,/usr/share/fonts/X11/75dpi,/var/lib/defoma/x-ttcidfont-conf.d/dirs/TrueType,built-ins" \
		--enable-aiglx \
		--enable-composite \
		--enable-record \
		--enable-xv \
		--enable-xvmc \
		--enable-dga \
		--enable-screensaver \
		--enable-xdmcp \
		--enable-xdm-auth-1 \
		--enable-glx \
		--disable-dri --enable-dri2 --disable-dri3 \
		--enable-xinerama \
		--enable-xf86vidmode \
		--enable-xace \
		--enable-xfree86-utils \
		--disable-dmx \
		--disable-xvfb \
		--disable-xnest \
		--disable-kdrive \
		--disable-xephyr \
		--enable-xfbdev \
		--with-sha1=libgcrypt \
		--enable-xcsecurity \
		--disable-docs \
		--disable-selective-werror)
	touch config-stamp

build-arch: config-stamp build-arch-stamp
build-arch-stamp:
	dh_testdir

	# Add here command to compile/build the package.
	# Build first things.
	# Build Xvnc
	make $(NUMJOBS) LDFLAGS="-lpng"
	make $(NUMJOBS) -C unix/xserver

	touch build-arch-stamp

build-indep: config-stamp  build-indep-stamp
build-indep-stamp:
	dh_testdir

	# Add here command to compile/build the arch indep package.
	# It's ok not to do anything here, if you don't need to build
	#  anything for this package.
	#/usr/bin/docbook-to-man debian/vnc.sgml > vnc.1
	(cd media;make)
	#(cd java;cmake -G"Unix Makefiles";make)

	touch build-indep-stamp

build: build-arch build-indep

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp config-stamp

	# Add here commands to clean up after the build process.
	dh_clean

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_prep
	dh_installdirs
	# Add here commands to install the package into debian/vnc.
	make install DESTDIR=$(CURDIR)/debian/tigervncserver
	(cd unix/xserver/hw/vnc; make install DESTDIR=$(CURDIR)/debian/tigervncserver)
	# rename server files to tigervnc specific names
	mv $(CURDIR)/debian/tigervncserver/usr/bin/Xvnc \
		$(CURDIR)/debian/tigervncserver/usr/bin/Xtigervnc
	mv $(CURDIR)/debian/tigervncserver/usr/bin/vncconfig \
		$(CURDIR)/debian/tigervncserver/usr/bin/tigervncconfig
	mv $(CURDIR)/debian/tigervncserver/usr/bin/vncpasswd \
		$(CURDIR)/debian/tigervncserver/usr/bin/tigervncpasswd
	mv $(CURDIR)/debian/tigervncserver/usr/bin/x0vncserver \
		$(CURDIR)/debian/tigervncserver/usr/bin/x0tigervncserver
	mv $(CURDIR)/debian/tigervncserver/usr/sbin/vncsession \
		$(CURDIR)/debian/tigervncserver/usr/sbin/tigervncsession
	mv $(CURDIR)/debian/tigervncserver/usr/lib/$(DEB_HOST_MULTIARCH)/vncserver \
		$(CURDIR)/debian/tigervncserver/usr/lib/$(DEB_HOST_MULTIARCH)/tigervncserver
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/vncconfig.1 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man1/tigervncconfig.1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/vncpasswd.1 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man1/tigervncpasswd.1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/x0vncserver.1 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man1/x0tigervncserver.1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/Xvnc.1 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man1/Xtigervnc.1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man8/vncsession.8 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man8/tigervncsession.8
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man8/vncserver.8 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man8/tigervncserver.8
	# delete development files
	rm -f $(CURDIR)/debian/tigervncserver/usr/lib/xorg/modules/extensions/libvnc.la
	# move viewer files to viewer package, rename on the fly
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/bin
	mv $(CURDIR)/debian/tigervncserver/usr/bin/vncviewer \
		$(CURDIR)/debian/xtigervncviewer/usr/bin/xtigervncviewer
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/share/man/man1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/vncviewer.1 \
		$(CURDIR)/debian/xtigervncviewer/usr/share/man/man1/xtigervncviewer.1
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/share
	mv $(CURDIR)/debian/tigervncserver/usr/share/applications \
		$(CURDIR)/debian/xtigervncviewer/usr/share/
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/share
	mv $(CURDIR)/debian/tigervncserver/usr/share/icons \
		$(CURDIR)/debian/xtigervncviewer/usr/share/
	# tigervnc-java
	#mkdir -p $(CURDIR)/debian/tigervnc-java/usr/share
	#(cd java; make install DESTDIR=$(CURDIR)/debian/tigervnc-java/usr/share)
	# install additional license files
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/share/doc/xtigervncviewer
	cp $(CURDIR)/debian/tigervncserver/usr/share/doc/tigervnc/* \

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

#DEB_HOST_MULTIARCH =

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

#export http_proxy=http://192.168.8.254:3130
export no_proxy="localhost"
export ftp_proxy=http://192.168.8.254:3138

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
#DEB_HOST_GNU_TYPE   = i686-linux-gnu
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
#DEB_BUILD_GNU_TYPE  = $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


# original
#export CFLAGS = -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export SERVERCFLAGS = -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export CXXFLAGS = -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export LDFLAGS = -Wl,--as-needed -Wl,--allow-multiple-definition -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=stringop-overread

# GCC 8 / Buster
#export CFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export SERVERCFLAGS = -lzstd -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export CXXFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export LDFLAGS = -lzstd -Wl,--as-needed -Wl,--allow-multiple-definition -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr
# Buster with lto
export CFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
export SERVERCFLAGS = -lzstd -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
export CXXFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
export LDFLAGS = -lzstd -lunistring -Wl,--as-needed -Wl,--allow-multiple-definition -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr

#export CFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export SERVERCFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export CXXFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export LDFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wl,--as-needed -Wl,--allow-multiple-definition -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=stringop-overread
#export CFLAGS = -nodefaultlibs -static-pie -lc -lm -lgcc -lgcc_eh -lunwind -llzma -ldl -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export SERVERCFLAGS = -nodefaultlibs -static-pie -lc -lm -lgcc -lgcc_eh -lunwind -llzma -ldl -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export CXXFLAGS = -nodefaultlibs -static-pie -lc -lm -lgcc -lgcc_eh -lunwind -llzma -ldl -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export LDFLAGS = -nodefaultlibs -static-pie -lc -lm -lgcc -lgcc_eh -lunwind -llzma -ldl -Wl,--as-needed -Wl,--allow-multiple-definition -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=stringop-overread

#LDFLAGS += -Wl,-Bstatic -lheif -lx265 -lde265 -laom -lopenh264 -Wl,-Bdynamic -Wno-error=return-local-addr
CMAKE_BUILD_TYPE = Debug
INCLDIR = /usr/include/

libsearch = $(shell find /lib /usr/lib -iname $(1) -print -quit)

TURBOJPEG = $(call libsearch,libturbojpeg.a)
GNUTLS = $(call libsearch,libgnutls.a)
NETTLE = $(call libsearch,libnettle.a)
TASN1 = $(call libsearch,libtasn1.a)
HOGWEED = $(call libsearch,libhogweed.a)
CRYPT = $(call libsearch,libcrypt.a)
GSASL = $(call libsearch,libgsasl.a)
IDN = $(call libsearch,libidn.a)
NTLM = $(call libsearch,libntlm.a)
Z = $(call libsearch,libz.a)
P11-KIT = $(call libsearch,libp11-kit.so)
GSSAPI_KRB5 = $(call libsearch,libgssapi_krb5.a)
KRB5 = $(call libsearch,libkrb5.a)
KRB5SUPPORT = $(call libsearch,libkrb5support.a)
K5CRYPTO = $(call libsearch,libk5crypto.a)
